import getWindow from '../dom-utils/getWindow';
export function onLoad(_ref) {
  var state = _ref.state,
      _ref$options = _ref.options,
      options = _ref$options === void 0 ? {} : _ref$options,
      instance = _ref.instance;
  var _options$scroll = options.scroll,
      scroll = _options$scroll === void 0 ? true : _options$scroll,
      _options$resize = options.resize,
      resize = _options$resize === void 0 ? true : _options$resize;

  if (scroll) {
    var scrollParents = [].concat(state.scrollParents.reference, state.scrollParents.popper);
    scrollParents.forEach(function (scrollParent) {
      return scrollParent.addEventListener('scroll', instance.update, {
        passive: true
      });
    });
  }

  if (resize) {
    var window = getWindow(state.elements.popper);
    window.addEventListener('resize', instance.update, {
      passive: true
    });
  }
}
export function onDestroy(_ref2) {
  var state = _ref2.state,
      _ref2$options = _ref2.options,
      options = _ref2$options === void 0 ? {} : _ref2$options,
      instance = _ref2.instance;
  var _options$scroll2 = options.scroll,
      scroll = _options$scroll2 === void 0 ? true : _options$scroll2,
      _options$resize2 = options.resize,
      resize = _options$resize2 === void 0 ? true : _options$resize2;

  if (scroll) {
    // Remove scroll event listeners
    var scrollParents = [].concat(state.scrollParents.reference, state.scrollParents.popper);
    scrollParents.forEach(function (scrollParent) {
      return scrollParent.removeEventListener('scroll', instance.update);
    });
  }

  if (resize) {
    // Remove resize event listeners
    var window = getWindow(state.elements.popper);
    window.removeEventListener('resize', instance.update);
  }
}
export default {
  name: 'offset',
  enabled: true,
  phase: 'write',
  fn: function fn(_ref3) {
    var state = _ref3.state;
    return state;
  },
  onLoad: onLoad,
  onDestroy: onDestroy
};