// source: https://stackoverflow.com/questions/49875255
var order = function order(modifiers) {
  // indexed by name
  var mapped = modifiers.reduce(function (mem, i) {
    mem[i.name] = i;
    return mem;
  }, {}); // inherit all dependencies for a given name

  var inherited = function inherited(i) {
    return mapped[i] && mapped[i].requires ? mapped[i].requires.reduce(function (mem, i) {
      return [].concat(mem, [i], inherited(i));
    }, []) : [];
  }; // order ...


  var ordered = modifiers.sort(function (a, b) {
    return !!~inherited(b.name).indexOf(a.name) ? -1 : 1;
  });
  return ordered;
};

export default (function (modifiers) {
  return ['read', 'main', 'afterMain', 'write'].reduce(function (acc, currentPhase) {
    return acc.concat(order(modifiers.filter(function (modifier) {
      return modifier.phase === currentPhase;
    })));
  }, []);
});